package com.zcloud.controller.system;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.entity.system.User;
import com.zcloud.service.system.AppFeedbackService;
import com.zcloud.service.system.UsersService;
import com.zcloud.util.*;
import org.apache.commons.io.FileUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.apache.shiro.session.Session;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import java.io.File;
import java.util.*;

/**
 * 说明：app意见反馈
 * 作者：luoxiaobao
 * 时间：2021-01-13
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/app/feedback")
public class AppFeedbackController extends BaseController {

	@Autowired
	private AppFeedbackService appfeedbackService;
	@Autowired
	private UsersService usersService;
	@Autowired
	private Smb smb;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
//	// @RequiresPermissions("appfeedback:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
	 	Session session = Jurisdiction.getSession();
	 	User loginUser = (User)session.getAttribute(Const.SESSION_USER);
		if(null != loginUser) {
	 		pd.put("CREAT", loginUser.getUSER_ID());
		 	pd.put("CREAT_NAME", loginUser.getUSERNAME());
		 	pd.put("CREAT_TIME", DateUtil.date2Str(new Date()));
	 	}
	 	if(!Tools.isEmpty(pd.get("loginUserId"))) {
	 		PageData userPd = new PageData();
	 		userPd.put("USER_ID", pd.getString("loginUserId"));
	 		PageData user = usersService.findById(userPd);
	 		pd.put("CREAT", user.get("USER_ID"));
		 	pd.put("CREAT_NAME", user.get("USERNAME"));
		 	pd.put("CREAT_TIME", DateUtil.date2Str(new Date()));
	 	}

	 	if(null != pd.get("FEEDBACK_IMG")) {
	 		String imgpath = pd.get("FEEDBACK_IMG").toString();
	 		pd.put("FEEDBACK_IMG",imgpath.subSequence(1, imgpath.length()));

	 	}
	 	//Const.FILEPATHFILE //图标位置
		pd.put("APPFEEDBACK_ID", this.get32UUID());	//主键
		appfeedbackService.save(pd);
		map.put("result", errInfo);
		return map;
	}
	/**完成
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/upload", headers = "content-type=multipart/form-data")
	@ResponseBody
	@Transactional
	public Object finish(
			@RequestParam(value="FFILE",required=false) MultipartFile[] files,
			@RequestParam(value="TYPE",required=false) String TYPE,
			@RequestParam(value="FOREIGN_KEY",required=false) String FOREIGN_KEY
			) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		String uploadPath = "";
        if (files != null && files.length > 0) {
            for (int i = 0; i < files.length; i++) {
                MultipartFile file = files[i];
//                 保存文件
                File tempFile = new File(file.getOriginalFilename());
        		FileUtils.copyInputStreamToFile(file.getInputStream(), tempFile);
        		if(!FileUpload.isImage(tempFile) && !TYPE.equals("2")) {//四色图改为json文件,不用判断类型
        			map.put("result", "failed");
        			map.put("exception", "上传图片格式不正确，请重新上传");
        			return map;
        		}
        		tempFile.delete();
        		PageData pd = new PageData();
        		pd = this.getPageData();

        		String  ffile = DateUtil.getDays();
//        		String filePath = PathUtil.getProjectpath() + Const.FILEPATHFILE + ffile;	//文件上传路径
//        		String fileName = FileUpload.fileUp(file, filePath, this.get32UUID());				//执行上传
        		String fileName = this.get32UUID()+file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
   			 	smb.sshSftp(file, fileName, Const.FILEPATHFILE + pd.getString("CORPINFO_ID") + "/" + ffile);

        		pd.put("IMGFILES_ID",  this.get32UUID());
        		pd.put("FILEPATH",  Const.FILEPATHFILE + pd.getString("CORPINFO_ID") + "/" + ffile + "/" + fileName);
        		pd.put("TYPE", TYPE);
        		pd.put("FOREIGN_KEY",  FOREIGN_KEY);
        		uploadPath += Const.FILEPATHFILE + pd.getString("CORPINFO_ID") + "/" + ffile + "/" + fileName;
            }
        }
		map.put("result", errInfo);
		map.put("imgPath", uploadPath);
		return map;
	}
	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("appfeedback:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		appfeedbackService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("appfeedback:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		appfeedbackService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("appfeedback:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		page.setPd(pd);
		List<PageData>	varList = appfeedbackService.list(page);	//列出AppFeedback列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("appfeedback:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = appfeedbackService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("appfeedback:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			appfeedbackService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("反馈标题");	//1
		titles.add("反馈类型");	//2
		titles.add("反馈建议");	//3
		titles.add("反馈图片地址");	//4
		titles.add("企业id");	//5
		titles.add("创建人id");	//6
		titles.add("创建人姓名");	//7
		titles.add("创建时间");	//8
		dataMap.put("titles", titles);
		List<PageData> varOList = appfeedbackService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("FEEDBACK_TITLE"));	    //1
			vpd.put("var2", varOList.get(i).getString("FEEDBACK_TYPE"));	    //2
			vpd.put("var3", varOList.get(i).getString("FEEDBACK_CONTENT"));	    //3
			vpd.put("var4", varOList.get(i).getString("FEEDBACK_IMG"));	    //4
			vpd.put("var5", varOList.get(i).getString("CORPINFO_ID"));	    //5
			vpd.put("var6", varOList.get(i).getString("CREAT"));	    //6
			vpd.put("var7", varOList.get(i).getString("CREAT_NAME"));	    //7
			vpd.put("var8", varOList.get(i).getString("CREAT_TIME"));	    //8
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
